import { ElementRef, QueryList } from '@angular/core';
import { FormControl } from '@angular/forms';
import { EventManager } from '@angular/platform-browser';
import 'rxjs/add/operator/debounceTime';
import 'rxjs/add/operator/distinctUntilChanged';
import { SandboxMenuItem, SelectedSandboxAndScenarioKeys } from '../lib/app-state';
import { StateService } from './shared/state.service';
import { UrlService } from './shared/url.service';
import { LevenshteinDistance } from './shared/levenshtein-distance';
import { Middleware } from '../lib/middlewares';
import { Observable } from 'rxjs/Observable';
export declare class AppComponent {
    private stateService;
    private urlService;
    private eventManager;
    private levenshteinDistance;
    private middleware;
    scenarioLinkElements: QueryList<ElementRef>;
    commandBarActive: boolean;
    commandBarPreview: boolean;
    totalSandboxes: number;
    filteredSandboxMenuItems: SandboxMenuItem[];
    selectedSandboxAndScenarioKeys: SelectedSandboxAndScenarioKeys;
    filter: FormControl;
    shortcuts: {
        keys: string[];
        description: string;
    }[];
    activeMiddleware: Middleware;
    constructor(stateService: StateService, urlService: UrlService, eventManager: EventManager, levenshteinDistance: LevenshteinDistance, middleware: Observable<Middleware>);
    ngOnInit(): void;
    onFilterBoxArrowDown(event: any, switchToScenario?: boolean): void;
    onFilterBoxArrowUp(event: any, switchToScenario?: boolean): void;
    onScenarioLinkKeyDown(scenarioElement: any, filterElement: any, event: any): void;
    onScenarioLinkKeyUp(scenarioElement: any, event: any): void;
    onScenarioLinkControlDown(scenarioElement: any, event: any): void;
    onScenarioLinkControlUp(scenarioElement: any, event: any): void;
    onCommandBarStartPreview(event: any): void;
    onCommandBarStopPreview(): void;
    onScenarioClick(sandboxKey: string, scenarioKey: number, event: any): void;
    isSelected(sandbox: any, scenario: any): boolean;
    toggleCommandBar(): void;
    private blockEvent(e);
    private showScenario(selectedScenarioElementRef);
    private findCurrentScenarioIndex();
    private goUp(scenarioElement);
    private goDown(scenarioElement);
    private focusScenarioLinkElement(index);
    private filterSandboxes(sandboxMenuItems, filter);
    private selectScenario(sandboxKey, scenarioKey);
    private getShortcuts();
}
